/**
* @class FPWindow
* @extends FPObject
* @classdesc Window component plays a role of a host for a single page of application's UI, it also allows navigation between windows.
* @fires windowWillAppear event right before window appears on screen
* @fires windowWillDisappear event right before window is removed from screen
* @example
* var wnd = new FPWindow();
* wnd.setTitle("Hello world");
* wnd.setLayout(layout);
* wnd.presentAsRootWindow();
*/
var FPWindow=FPObject.extend({className:"FPWindow",init:function(){this._super()},setLayout:function(e){Bridge.call({command:this.className+"#setLayout",layout:e.hasOwnProperty("layout")?e.layout.__id:e.__id,__id:this.__id})},setTitle:function(e){Bridge.call({command:this.className+"#setTitle",title:e.hasOwnProperty("title")?e.title:e,__id:this.__id})},setMenu:function(e){var i=e.hasOwnProperty("menu")?e.menu:e
i.forEach(function(e){e.view&&(e.view=e.view.__id)}),Bridge.call({command:this.className+"#setMenu",menu:i,callbacks:{onItemClick:e.onMenuItemClick},__id:this.__id})},setIcon:function(e){Bridge.call({command:this.className+"#setIcon",icon:e.hasOwnProperty("icon")?e.icon:e,__id:this.__id})},setTheme:function(e){Bridge.call({command:this.className+"#setTheme",primaryColor:e.primaryColor,accentColor:e.accentColor,titleTextColor:e.titleTextColor,__id:this.__id})},transitionToWindow:function(e){Bridge.call({command:this.className+"#transitionToWindow",window:e.hasOwnProperty("window")?e.window.__id:e.__id,__id:this.__id})},transitionBack:function(){Bridge.call({command:this.className+"#transitionBack",__id:this.__id})},presentAsRootWindow:function(){Bridge.call({command:this.className+"#presentAsRootWindow",__id:this.__id})}}),FPDrawerWindow=FPWindow.extend({className:"FPDrawerWindow",init:function(){this._super()},setDrawerLayout:function(e){Bridge.call({command:this.className+"#setDrawerLayout",layout:e.hasOwnProperty("layout")?e.layout.__id:e.__id,__id:this.__id})}}),FPDialogWindow=FPWindow.extend({className:"FPDialogWindow",init:function(){this._super()},dimissFromRoot:function(){Bridge.call({command:this.className+"#dimissFromRoot",__id:this.__id})}}),FPView=FPObject.extend({className:"FPView",init:function(e){this._super(e)},setWeight:function(e){Bridge.call({command:this.className+"#setWeight",weight:e.hasOwnProperty("weight")?e.weight:e,__id:this.__id})},setGravity:function(e){Bridge.call({command:this.className+"#setGravity",gravity:e.hasOwnProperty("gravity")?e.gravity:e,__id:this.__id})},setSize:function(e){Bridge.call({command:this.className+"#setSize",width:"undefined"==typeof e.width?-1:e.width,height:"undefined"==typeof e.height?-1:e.height,__id:this.__id})},setBackgroundColor:function(e){Bridge.call({command:this.className+"#setBackgroundColor",color:e.hasOwnProperty("color")?e.color:e,__id:this.__id})},setBackgroundImage:function(e){Bridge.call({command:this.className+"#setBackgroundImage",image:e.hasOwnProperty("fileName")?e.fileName:e,mode:e.mode,__id:this.__id})},setMargin:function(e){Bridge.call({command:this.className+"#setMargin",margin:e.hasOwnProperty("margin")?e.margin:e,__id:this.__id})},setGradient:function(e){Bridge.call({command:this.className+"#setGradient",start:e.startColor,center:e.centerColor,end:e.endColor,angle:e.angle,__id:this.__id})},setHidden:function(e){Bridge.call({command:this.className+"#setHidden",hidden:e.hasOwnProperty("hidden")?e.hidden:e,__id:this.__id})},setViewId:function(e){Bridge.call({command:this.className+"#setViewId",viewId:e.hasOwnProperty("viewId")?e.viewId:e,__id:this.__id})},getViewId:function(e){return Bridge.call({command:this.className+"#getViewId",__sync:!0,__id:this.__id})},setAttributes:function(e){Bridge.call({command:this.className+"#setAttributes",attributes:e.hasOwnProperty("attributes")?e.attributes:e,__id:this.__id})},setEnabled:function(e){Bridge.call({command:this.className+"#setEnabled",enabled:e.hasOwnProperty("enabled")?e.enabled:e,__id:this.__id})},setTitle:function(e){Bridge.call({command:this.className+"#setTitle",title:e.hasOwnProperty("title")?e.title:e,__id:this.__id})}}),FPDataModel=FPObject.extend({className:"FPDataModel",init:function(){this._super()},setData:function(e){Bridge.call({command:this.className+"#setData",items:e.hasOwnProperty("items")?e.items:e,__id:this.__id})},getData:function(e){return Bridge.call({command:this.className+"#getData",__id:this.__id,__sync:!0})},appendData:function(e){var i=e.hasOwnProperty("json"),t=e.hasOwnProperty("items")
Bridge.call({command:this.className+"#appendData",items:t?e.items:i?null:e,json:i?e.json:null,__id:this.__id})},setFilter:function(e){Bridge.call({command:this.className+"#setFilter",filter:e.hasOwnProperty("filter")?e.filter:e,__id:this.__id})}}),FPListView=FPView.extend({className:"FPListView",init:function(e){this._super(e)},setDataModel:function(e){Bridge.call({command:this.className+"#setDataModel",dataModel:e.hasOwnProperty("dataModel")?e.dataModel.__id:e.__id,__id:this.__id})},setRowTemplate:function(e){Bridge.call({command:this.className+"#setRowTemplate",fileName:e.hasOwnProperty("fileName")?e.fileName:e,__id:this.__id})},setEmptyView:function(e){Bridge.call({command:this.className+"#setEmptyView",view:e.hasOwnProperty("view")?e.view.__id:e.__id,__id:this.__id})},endRefreshing:function(){Bridge.call({command:this.className+"#endRefreshing",__id:this.__id})},enablePullToRefresh:function(e){Bridge.call({command:this.className+"#enablePullToRefresh",enabled:e.hasOwnProperty("enabled")?e.enabled:e,__id:this.__id})}}),FPGridView=FPListView.extend({className:"FPGridView",init:function(e){this._super(e)},setColumns:function(e){Bridge.call({command:this.className+"#setColumns",columns:e.hasOwnProperty("columns")?e.columns:e,__id:this.__id})}}),FPProgressBar=FPView.extend({className:"FPProgressBar",init:function(e){this._super(e)},setProgress:function(e){Bridge.call({command:this.className+"#setProgress",progress:e.hasOwnProperty("progress")?e.progress:e,animated:e.hasOwnProperty("animated")?e.animated:!0,__id:this.__id})}}),FPSlider=FPView.extend({className:"FPSlider",init:function(e){this._super(e)},setMinValue:function(e){Bridge.call({command:this.className+"#setMinValue",minValue:e.hasOwnProperty("minValue")?e.progress:e,__id:this.__id})},setMaxValue:function(e){Bridge.call({command:this.className+"#setMaxValue",maxValue:e.hasOwnProperty("maxValue")?e.progress:e,__id:this.__id})},setValue:function(e){Bridge.call({command:this.className+"#setValue",value:e.hasOwnProperty("value")?e.progress:e,animated:e.hasOwnProperty("animated")?e.animated:!0,__id:this.__id})},setContinuous:function(e){Bridge.call({command:this.className+"#setContinuous",continuous:e.hasOwnProperty("continuous")?e.progress:e,__id:this.__id})}}),FPImageView=FPView.extend({className:"FPImageView",init:function(e){this._super(e)},setUrl:function(e){Bridge.call({command:this.className+"#setUrl",url:e.hasOwnProperty("url")?e.url:e,__id:this.__id})},setScaleType:function(e){Bridge.call({command:this.className+"#setScaleType",scaleType:e.hasOwnProperty("scaleType")?e.scaleType:e,__id:this.__id})},setImage:function(e){Bridge.call({command:this.className+"#setImage",image:e.hasOwnProperty("fileName")?e.fileName:e,__id:this.__id})}}),FPScrollView=FPView.extend({className:"FPScrollView",init:function(e){this._super(e)},setContentView:function(e){Bridge.call({command:this.className+"#setContentView",view:e.hasOwnProperty("view")?e.view.__id:e.__id,__id:this.__id})}}),FPWebView=FPView.extend({className:"FPWebView",init:function(e){this._super(e)},loadUrl:function(e){Bridge.call({command:this.className+"#loadUrl",callbacks:{onLoad:e.onLoad,onFail:e.onFail},url:e.hasOwnProperty("url")?e.url:e,__id:this.__id})},loadFile:function(e){Bridge.call({command:this.className+"#loadFile",callbacks:{onLoad:e.onLoad,onFail:e.onFail},fileName:e.hasOwnProperty("fileName")?e.fileName:e,__id:this.__id})}}),FPLayout=FPView.extend({className:"FPLayout",init:function(e){var i=void 0
"vertical"!=e&&"horizontal"!=e&&"card"!=e&&(i=e),this._super(i),void 0===i&&Bridge.call({command:this.className+"#setOrientation",orientation:e,__id:this.__id})},addView:function(e){Bridge.call({command:this.className+"#addView",view:e.hasOwnProperty("view")?e.view.__id:e.__id,__id:this.__id})},addViews:function(e){viewsArray=e.hasOwnProperty("views")?e.views:e
var i=[]
viewsArray.forEach(function(e){e.__id&&i.push(e.__id)}),Bridge.call({command:this.className+"#addViews",views:i,__id:this.__id})},getViewByName:function(e){var i=Bridge.call({command:this.className+"#getViewByName",name:e.hasOwnProperty("name")?e.name:e,__id:this.__id,__sync:!0})
return i&&0!=i.length?instanceFromMap(i):null}}),FPCardLayout=FPLayout.extend({className:"FPCardLayout",init:function(e){"undefined"!=typeof e?this._super(e):this._super("card")},showCard:function(e){Bridge.call({command:this.className+"#showCard",view:e.hasOwnProperty("view")?e.view.__id:e.__id,animation:"undefined"==typeof e.animation?"":e.animation,__id:this.__id})},showCardAtIndex:function(e){Bridge.call({command:this.className+"#showCardAtIndex",index:e.hasOwnProperty("index")?e.index:e,animation:"undefined"==typeof e.animation?"":e.animation,__id:this.__id})}}),FPPagesLayout=FPLayout.extend({className:"FPPagesLayout",init:function(e){"undefined"!=typeof e?this._super(e):this._super("card")}}),FPTabsLayout=FPLayout.extend({className:"FPTabsLayout",init:function(e){"undefined"!=typeof e?this._super(e):this._super("card")},setTitleColor:function(e){Bridge.call({command:this.className+"#setTitleColor",color:e.hasOwnProperty("color")?e.color:e,__id:this.__id})},setSelectedTitleColor:function(e){Bridge.call({command:this.className+"#setSelectedTitleColor",color:e.hasOwnProperty("color")?e.color:e,__id:this.__id})},setSelectedIndicatorColor:function(e){Bridge.call({command:this.className+"#setSelectedIndicatorColor",color:e.hasOwnProperty("color")?e.color:e,__id:this.__id})},selectTabAtIndex:function(e){Bridge.call({command:this.className+"#selectTabAtIndex",index:e.hasOwnProperty("index")?e.index:e,animated:e.hasOwnProperty("animated")?e.animated:!0,__id:this.__id})},getSelectedTabIndex:function(e){return Bridge.call({command:this.className+"#getSelectedTabIndex",__sync:!0,__id:this.__id})}}),FPActivityIndicator=FPView.extend({className:"FPActivityIndicator",init:function(e){this._super(e)}}),FPSearchView=FPView.extend({className:"FPSearchView",init:function(e){this._super(e)},getQuery:function(){return Bridge.call({command:this.className+"#getQuery",__sync:!0,__id:this.__id})},setQuery:function(e){Bridge.call({command:this.className+"#setQuery",query:e.hasOwnProperty("query")?e.query:e,__id:this.__id})},setHint:function(e){Bridge.call({command:this.className+"#setHint",hint:e.hasOwnProperty("hint")?e.hint:e,__id:this.__id})},setTextColor:function(e){Bridge.call({command:this.className+"#setTextColor",color:e.hasOwnProperty("color")?e.color:e,__id:this.__id})},setSuggestions:function(e){Bridge.call({command:this.className+"#setSuggestions",suggestions:e.hasOwnProperty("suggestions")?e.suggestions:e,autoFilter:e.hasOwnProperty("autoFilter")?e.autoFilter:!0,__id:this.__id})}}),FPButton=FPView.extend({className:"FPButton",init:function(e){this._super(e)},setTitle:function(e){Bridge.call({command:this.className+"#setTitle",title:e.hasOwnProperty("title")?e.title:e,__id:this.__id})},setTextColor:function(e){Bridge.call({command:this.className+"#setTextColor",color:e.hasOwnProperty("color")?e.color:e,__id:this.__id})}}),FPCheckBox=FPButton.extend({className:"FPCheckBox",init:function(e){this._super(e)},setChecked:function(e){Bridge.call({command:this.className+"#setChecked",checked:e.hasOwnProperty("checked")?e.checked:e,__id:this.__id})},isChecked:function(){return Bridge.call({command:this.className+"#isChecked",__sync:!0,__id:this.__id})},setTitle:function(e){Bridge.call({command:this.className+"#setTitle",title:e.hasOwnProperty("title")?e.title:e,__id:this.__id})},getTitle:function(){return Bridge.call({command:this.className+"#getTitle",__id:this.__id,__sync:!0})}}),FPLabel=FPView.extend({className:"FPLabel",init:function(e){this._super(e)},setTitle:function(e){Bridge.call({command:this.className+"#setTitle",title:e.hasOwnProperty("title")?e.title:e,__id:this.__id})},getTitle:function(){return Bridge.call({command:this.className+"#getTitle",__id:this.__id,__sync:!0})},setAlign:function(e){Bridge.call({command:this.className+"#setAlign",align:e.hasOwnProperty("align")?e.align:e,__id:this.__id})},setTextColor:function(e){Bridge.call({command:this.className+"#setTextColor",color:e.hasOwnProperty("textColor")?e.textColor:e,__id:this.__id})},setTextSize:function(e){Bridge.call({command:this.className+"#setTextSize",size:e.hasOwnProperty("textSize")?e.textSize:e,__id:this.__id})},setTypeface:function(e){Bridge.call({command:this.className+"#setTypeFace",typeface:e.hasOwnProperty("typeface")?e.typeface:e,__id:this.__id})},setMaxLines:function(e){Bridge.call({command:this.className+"#setMaxLines",maxLines:e.hasOwnProperty("maxLines")?e.maxLines:e,__id:this.__id})}}),FPTextField=FPView.extend({className:"FPTextField",init:function(e){this._super(e)},setText:function(e){Bridge.call({command:this.className+"#setText",title:e.hasOwnProperty("text")?e.text:e,__id:this.__id})},getText:function(){return Bridge.call({command:this.className+"#getText",__sync:!0,__id:this.__id})},setAlign:function(e){Bridge.call({command:this.className+"#setAlign",align:e.hasOwnProperty("align")?e.align:e,__id:this.__id})},setTextColor:function(e){Bridge.call({command:this.className+"#setTextColor",color:e.hasOwnProperty("textColor")?e.textColor:e,__id:this.__id})},setTextSize:function(e){Bridge.call({command:this.className+"#setTextSize",size:e.hasOwnProperty("textSize")?e.textSize:e,__id:this.__id})},setTypeface:function(e){Bridge.call({command:this.className+"#setTypeFace",typeface:e.hasOwnProperty("typeface")?e.typeface:e,__id:this.__id})},setSecure:function(e){Bridge.call({command:this.className+"#setSecure",secure:e.hasOwnProperty("secure")?e.secure:e,__id:this.__id})},setPlaceholder:function(e){Bridge.call({command:this.className+"#setPlaceholder",placeholder:e.hasOwnProperty("placeholder")?e.placeholder:e,__id:this.__id})},setPlaceholderColor:function(e){Bridge.call({command:this.className+"#setPlaceholderColor",placeholderColor:e.hasOwnProperty("placeholderColor")?e.placeholderColor:e,__id:this.__id})}}),FPMapView=FPView.extend({className:"FPMapView",init:function(e){this._super(e)},setMyLocationEnabled:function(e){Bridge.call({command:this.className+"#setMyLocationEnabled",locationEnabled:e.hasOwnProperty("locationEnabled")?e.locationEnabled:e,__id:this.__id})},setCenter:function(e){Bridge.call({command:this.className+"#setCenter",latitude:e.latitude,longitude:e.longitude,animated:e.animated,__id:this.__id})},setZoom:function(e){Bridge.call({command:this.className+"#setZoom",zoom:e.hasOwnProperty("zoom")?e.zoom:e,__id:this.__id})},addOverlay:function(e){Bridge.call({command:this.className+"#addOverlay",uid:e.uid,latitude:e.latitude,longitude:e.longitude,title:e.title,description:e.description,icon:e.icon,image:e.image,callbacks:{onClick:e.onClick,onInfoClick:e.onInfoClick},__id:this.__id})}}),FPUILoader=FPObject.extend({className:"FPUILoader",init:function(){this._super()},loadXML:function(e){if("undefined"!=typeof e.files&&e.files.constructor==Array){var i=(e.files.length,this)
i.viewsObject||(i.viewsObject={})
var t=e.files.shift()
Bridge.call({command:i.className+"#loadXML",fileName:t,callbacks:{success:function(s){var a=instanceFromMap(s)
i.viewsObject[t]=a,0==e.files.length?e.success.apply(i,[i.viewsObject]):i.loadXML({files:e.files,success:e.success,failure:e.failure})},failure:e.failure},__id:i.__id})}}}),FPMailComposer=FPObject.extend({className:"FPMailComposer",init:function(){this._super()},compose:function(e){Bridge.call({command:this.className+"#compose",subject:e.subject,body:e.body,format:e.format,__id:this.__id})},present:function(){Bridge.call({command:this.className+"#present",__id:this.__id})}}),FPDatePicker=FPObject.extend({className:"FPDatePicker",init:function(){this._super()},setDate:function(e){Bridge.call({command:this.className+"#setDate",year:e.year,month:e.month,day:e.day,__sync:!0,__id:this.__id})},present:function(e){Bridge.call({command:this.className+"#present",callbacks:{onDateSet:e.hasOwnProperty("onDateSet")?e.onDateSet:e},__id:this.__id})}}),FPTimePicker=FPObject.extend({className:"FPTimePicker",init:function(){this._super()},setTime:function(e){Bridge.call({command:this.className+"#setTime",hour:e.hour,minute:e.minute,__sync:!0,__id:this.__id})},present:function(e){Bridge.call({command:this.className+"#present",callbacks:{onTimeSet:e.hasOwnProperty("onTimeSet")?e.onTimeSet:e},__id:this.__id})}}),Animation={FADE:"fade",PUSH_RIGHT:"pushright",PUSH_LEFT:"pushleft",FLIP_RIGHT:"flipright",FLIP_LEFT:"flipleft"},Size={WRAP_CONTENT:"wrap",MATCH_PARENT:"match"},Gravity={CENTER:"center",LEFT:"left",RIGHT:"right",TOP:"top",BOTTOM:"bottom",TOP_LEFT:"top-left",TOP_RIGHT:"top-right",BOTTOM_LEFT:"bottom-left",BOTTOM_RIGHT:"bottom-right"}
